<?php
/**
* Page to test the functionality of the DICOM package
*/

define("DIR_DICOM_FS", getcwd() . "/");
define("DIR_DICOM_UPLOAD_FS", DIR_DICOM_FS . "upload/");
define("DIR_DICOM_UPLOAD_WEB", "upload/");
define("DIR_DICOM_UPLOAD_ZIP_FS", DIR_DICOM_UPLOAD_FS . "zip/");

$output = "";
$phpallowuploads = (bool) ini_get('file_uploads');       
$phpmaxsize = ini_get('upload_max_filesize');
$phpmaxsize = trim($phpmaxsize);
$last = strtolower($phpmaxsize{strlen($phpmaxsize)-1});
switch($last) {
    case 'g':
        $phpmaxsize *= 1024;
    case 'm':
        $phpmaxsize *= 1024;
}
   
// A file was sent   
if (isset($_FILES['new_file'])) {
	
    	// Here starts the file upload
	    $ftmp = $_FILES['new_file']['tmp_name'];
	    $oname = $_FILES['new_file']['name'];
	    $target_dir = DIR_DICOM_UPLOAD_FS;
	    $fn_array = explode('.', $oname); 
	    $ext = strtolower(end($fn_array));
    $fname =  $target_dir . $_FILES['new_file']['name'];
	    $fname = str_replace("'","_",$fname);
	    $ftmp = str_replace("'","_",$ftmp);
	    $oname = str_replace("'","_",$oname);
    	//  Let's make sure the directory exists and is writable first.
	    clearstatcache();
	    if (!is_dir(DIR_DICOM_FS)) {
		        mkdir(DIR_DICOM_FS, 0700);	
	    }
		    if (!is_dir(DIR_DICOM_UPLOAD_FS)) {
		        mkdir(DIR_DICOM_UPLOAD_FS, 0700);	
	    }
		    if (!is_dir(DIR_DICOM_UPLOAD_ZIP_FS)) {
		        mkdir(DIR_DICOM_UPLOAD_ZIP_FS, 0700);	
	    }
	    $file_to_check = $fname;
	    if (file_exists($file_to_check)) {
		        unlink($file_to_check);
		        //$output = "<script>
		        //alert('Document with the same name already exists. Please choose another file.');
		        //</script>";
	    }
	    //else {
    		    if(move_uploaded_file($ftmp, str_replace("'","_",$fname))) {
			
    			        //  For type and name
        			    $fn_array = explode('.', $fname); 
        			    $type = strtolower(end($fn_array));
			            $fn_array = explode('/', $fname); 
			            $name = end($fn_array);		
			
		        }
		
		        require_once(DIR_DICOM_FS."DICOM.php");
		        $dicom = new File_DICOM();

        // Check if file is a zip
		        if ($type == "zip") {
            // It is a zip file. Then create the ZIP object		    
			            $zip = new ZipArchive();
			            $zip->open($fname);  // Open the zip file
			
			            $output = "Filename: " . $fname . "<br />\n"; // Showing the name

		            $number_of_files = 0;
			            for ($i=0; $i<$zip->numFiles;$i++) {
        			        // Renaming the name of files.
            			    // Because some file might have extra path relative to the root of the zip file, here we are
            			    //  renaming the file names to temporary names with the format:
            			    //  "nameOfFileWithNoExtension_ConsecutiveIndex.tmp"
        			        $fileInfo = $zip->statIndex($i);
        			        if (substr($fileInfo["name"],-1) == "/") {
        			            // It is a dir
       			             $zip->deleteIndex($i);
			                }
			                else {
           			         // It is a file
       			             $zip->renameIndex($i,substr($name,0,-4)."_".$number_of_files.".tmp");
            			        //$output .= substr($name,0,-4)."_".$number_of_files.".tmp" . "<br />";
       			             $number_of_files++;
                }
            }
            			// Closing zip file
        			    $zip->close();
            			// Opening again to reflect the change of names above
        			    $zip->open($fname);
            
    			        $output .= "Number of Files: " . $zip->numFiles . "<br />\n"; // Showing the number of file
            // Variable to hold the number of DICOM files
    		        $number_of_DICOM_files = 0;
            			// Let's extract the files to a known location
			            if ($zip->extractTo(DIR_DICOM_UPLOAD_ZIP_FS)=== TRUE) {
    			            $output .= "Extraction was completed <br />"; // Extracted OK
                // Going thru all the files
                for ($i=0; $i<$zip->numFiles;$i++) {
                    // Checking if file is DICOM or not
                    if ($dicom->isDICOM(DIR_DICOM_UPLOAD_ZIP_FS.substr($name,0,-4)."_".$i.".tmp")) {
                        // Is DICOM, let's move it to the incoming directory for the DICOM receiver
                        $output .= "File " . substr($name,0,-4)."_".$i.".tmp" . " is DICOM <br />"; // File is DICOM
                    }
                    else {
                        $output .= "File" . substr($name,0,-4)."_".$i.".tmp" . " might not be DICOM <br />"; // File is DICOM
                        // It is not DICOM, let's erase it
                        //unlink(DIR_DICOM_FS."Upload/zip/".substr($name,0,-4)."_".$i.".tmp");
                    }
                    $number_of_DICOM_files++;
                }
			            }
			            else {
    			            $output .= "Extraction was not successful <br />"; // Extracted not OK
			            }
			            $zip->close();
            			// Checking if we got at least one DICOM file inside the zip file
			            if ($number_of_DICOM_files > 0) {
	        		        // Let's remove the original zip file
       			         unlink($fname);
           			     // Let's replace the original zip file with the first extracted file from zip
           			     // This is the file I need to send to the DICOM receiver to trigger the DICOM parser.
			                rename(DIR_DICOM_FS."Upload/zip/".substr($name,0,-4)."_0.tmp", $fname); 
			            }
			            else {
                // No DICOM file found. fname should be empty			    
                $fname = "";
			            }
		        }
		        else {
        			    // It is not a zip file, maybe a single DICOM file.
        			    $isDicom = $dicom->isDicom($fname);
        			    if (!$isDicom) {
        			    	  echo "File is not DICOM. Please try again";
        			    	  exit();
        			    }
        			    $res = $dicom->parse($fname);
			
			            // check for errors
			            if (PEAR::isError($res)) {
			               die("Error: ".$res->getMessage()."\n");
			            }
			            $thumbnail = "";
            			// show a few attributes of the DICOM file using group and element index
			            $output .= $dicom->htmlParse();
			            if (isset($dicom->_elements[0x7FE0][0x0010])) {
				
                				// Return the resource image alone
				                $images = $dicom->imagecreatefromDICOM ($fname);
	  
                				if (!empty($images)) {
                    					if (count($images) == 1) {
					                        $number = "";
					                    }
					                    else {
    					                    $number = 1;
					                    }
					                    foreach ($images as $im) {
	                        imagejpeg($im, $fname."_$number.jpg");
	                        imagedestroy($im);
	                        $thumbnail .= "<a href=\"" . DIR_DICOM_UPLOAD_WEB. "${name}_${number}.jpg\" target=\"_blank\" display=\"inline\"><img src=\"" . DIR_DICOM_UPLOAD_WEB . "${name}_${number}.jpg\" height=\"16\" width=\"16\" display=\"inline\" /></a>";
	                        if (!empty($number)) {
	                            $number++;    
	                        }
					                    }
				                }
			            }
			            $output .= "<br />"; 		
			            $output .= "<br />";
			            $output = "$thumbnail $name<br /><br />" . $output;
			            $new = 1;
		        }
    //}
	}

$output = "
<style>
#file {
	    width: 20em;
    border: 1px solid black;
    color: black;
}
img {
	    float:left;
	    margin:2px;
}
</style>
<strong>Upload a File</strong> (Max Filesize: ${phpmaxsize}KB)
<form name=\"iform\" action=\"\" method=\"post\" enctype=\"multipart/form-data\">
<input id=\"file\" type=\"file\" name=\"new_file\" />
<input type=\"submit\" value=\"Send\" class=\"submit\" />
</form>
$output";

echo 
"
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"
                      \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">
<head>
 <title>File_DICOM test page</title>
</head>
<body>
$output
<script src=\"http://www.google-analytics.com/urchin.js\" type=\"text/javascript\">
</script>
<script type=\"text/javascript\">
_uacct = \"UA-516408-4\";
urchinTracker();
</script>
</body>
</html>";
?>